//Revisions by Trainman, July 26, 2012
#property copyright "Extreme TMA System"
#property link      "http://www.forexfactory.com/showthread.php?t=343533m"

#property indicator_chart_window
#property indicator_buffers    8
#property indicator_color1     CLR_NONE
#property indicator_color2     White
#property indicator_color3     White
#property indicator_color4     Lime 
#property indicator_color5     Red
#property indicator_color6     White
#property indicator_color7     Lime
#property indicator_color8     Red
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property  indicator_width1 1
#property  indicator_width2 1
#property  indicator_width3 1
#property  indicator_width4 1
#property  indicator_width5 1
#property  indicator_width6 1

#define PIPSTOFORCERECALC 10

extern string TimeFrame       = "Current";
extern int    TMAPeriod      = 14;  //56
extern int    Price           = PRICE_CLOSE;
extern double ATRMultiplier   = 2.0;
extern int    ATRPeriod       = 100;
extern double TrendThreshold = 0.5;
extern bool ShowCenterLine = true;
extern int    Bar       = 0;

extern bool   alertsOn        = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   MoveEndpointEveryTick = false;
extern int    MaxBarsBack     = 5000;
extern int    TShift      = 1;
extern int    UpDn     = 50.0;
extern int    RUpCL    = -60.0;
extern bool   Upper50        = false;
extern bool   RangeTma       = false;
extern int	EmaPeriod50	   = 50;
extern int	EmaPeriod14	   = 14;
extern int  EmaPrice       = 0;
extern int  EmaMode        = 2;
extern int  EmaPrice50       = 1;
extern int  EmaMode50        = 3;
extern int  ArSize           = 1;

extern string ____________LevelUp____;
extern double                  Dn=-10;
extern bool      UPAlert=false;
extern bool      SoundAlto=false;  
extern string ____________LevelDn____;
extern string ____________SET____AlertDOWN;
extern double                  Up=10;
extern bool DOWNAlert=false;
extern bool SoundBasso=false;
extern string FileSoundUP = "alert.wav";
extern string FileSoundDOWN = "alert2.wav";
int PlayedSoundH = False;
int PlayedSoundL = False;
int PlayedSoundH2 = False;
int PlayedSoundL2 = False;

double tma[];
double upperBand[];
double lowerBand[];
double bull[];
double bear[];
double neutral[];
double ArrowUp[];
double ArrowDn[];
 
int    TimeFrameValue,
       FirstAvailableBar;
bool AlertHappened;
datetime AlertTime;
double TICK;
bool AdditionalDigit;
double  SumTMAPeriod,
        TickScaleFactor,
        Threshold,
        PriorTick,
        FullSumW;

int init()
{
  AdditionalDigit = MarketInfo(Symbol(), MODE_MARGINCALCMODE) == 0 && MarketInfo(Symbol(), MODE_PROFITCALCMODE) == 0 && Digits % 2 == 1;

  TICK = MarketInfo(Symbol(), MODE_TICKSIZE);
  if (AdditionalDigit)
    TICK *= 10;

  TimeFrameValue         = stringToTimeFrame(TimeFrame);
             
  IndicatorBuffers(8); 
  SetIndexBuffer(0,tma); 
  SetIndexBuffer(1,upperBand); 
  SetIndexBuffer(2,lowerBand); 
  SetIndexBuffer(3,bull); 
  SetIndexBuffer(4,bear); 
  SetIndexBuffer(5,neutral); 
  SetIndexBuffer(6,ArrowUp); 
  SetIndexBuffer(7,ArrowDn); 
  SetIndexStyle(6,DRAW_ARROW,0,ArSize);
  SetIndexArrow(6, 233);
  SetIndexStyle(7,DRAW_ARROW,0,ArSize);
  SetIndexArrow(7, 234);
  
  //SetIndexLabel(0, "FastTMA " + TimeFrame + ")");  
  SetIndexLabel(1, "FastTMA " + TimeFrame + " Upper line");  
  SetIndexLabel(2, "FastTMA " + TimeFrame + " Lower line");  
  SetIndexLabel(3, "FastTMA(" + TimeFrame + ")");  
  SetIndexLabel(4, "FastTMA(" + TimeFrame + ")");  
  SetIndexLabel(5, "FastTMA(" + TimeFrame + ")");  

  IndicatorShortName(TimeFrameValueToString(TimeFrameValue)+" TMA bands ("+TMAPeriod+")");
  SumTMAPeriod = 0;
  for (int i = 1; i <= TMAPeriod; i++)
    SumTMAPeriod += i;
  FullSumW = TMAPeriod + 1 + 2 * SumTMAPeriod;
  TickScaleFactor = (TMAPeriod + 1) / (TMAPeriod + 1 + SumTMAPeriod); // relative weight of latest tick
  PriorTick = Close[0];
  if (Digits < 4)
    Threshold = PIPSTOFORCERECALC * 0.01;
  else
    Threshold = PIPSTOFORCERECALC * 0.0001;
    
  FirstAvailableBar = iBars(NULL, TimeFrameValue) - TMAPeriod - 1;
  return(0);
}
int deinit() { return(0); }


int start()
{
  int counted_bars=IndicatorCounted();
  if(counted_bars<0) return(-1);
  if(Period() > TimeFrameValue) 
    return(0); // don't plot lower TFs on upper TF charts

  int i,j,k,limit;
  static double PriceAtFullRecalc = 0;
  static double range = 0;
  static double slope = 0;
  // if (uncounted bars are zero and price change is small)
  if (((Bars - counted_bars) == 1) && (MathAbs(Close[0] - PriceAtFullRecalc) < Threshold))
    {
    if (MoveEndpointEveryTick)
      { // incremental change to end point
      tma[0] = CalcTmaUpdate(tma[0]);
      upperBand[0] = tma[0] + range;
      lowerBand[0] = tma[0] - range;
      DrawCenterLine(0, slope);   
      }
    else
      return(0);
    }
  else // complete recalculation
    {
    PriceAtFullRecalc = Close[0];
    if(counted_bars>0) counted_bars--;
    double barsPerTma = (TimeFrameValue / Period());
    limit=MathMin(Bars-1, MaxBarsBack); 
    limit=MathMin(limit,Bars-counted_bars+ TMAPeriod * barsPerTma ); 
   
    int mtfShift = 0;
    int lastMtfShift = 999;
    double prevTma = tma[limit+1];
    double tmaVal = tma[limit+1];
    for (i=limit; i>=0; i--)
      {
      if (TimeFrameValue == Period())
        {
        mtfShift = i;
        }
      else
        {         
        mtfShift = iBarShift(Symbol(),TimeFrameValue,Time[i]);
        } 
      
      if (mtfShift > FirstAvailableBar) continue; // exceeded available historical data
      if(mtfShift == lastMtfShift)
        {       
        tma[i] =tma[i+1] + ((tmaVal - prevTma) * (1/barsPerTma));         
        upperBand[i] = tma[i] + range;
        lowerBand[i] = tma[i] - range;
        DrawCenterLine(i, slope);   
        continue;
        }
      
      lastMtfShift = mtfShift;
      prevTma = tmaVal;
      tmaVal = CalcTma(mtfShift);
      
      range = iATR(NULL,TimeFrameValue,ATRPeriod,mtfShift+10)*ATRMultiplier;
      if(range == 0) range = 1;
      
      if (barsPerTma > 1)
        {
        tma[i] =prevTma + ((tmaVal - prevTma) * (1/barsPerTma));
        }
      else
        {
        tma[i] =tmaVal;
        }
      upperBand[i] = tma[i]+range;
      lowerBand[i] = tma[i]-range;

      slope = (tmaVal-prevTma) / ((range / ATRMultiplier) * 0.1);
            
      DrawCenterLine(i, slope);
          
      }
    }

   manageAlerts();
   return(0);
}

void DrawCenterLine(int shift, double slope)
{

   bull[shift] = EMPTY_VALUE;
   bear[shift] = EMPTY_VALUE;          
   neutral[shift] = EMPTY_VALUE; 
   if (ShowCenterLine)
   {
      if(slope > TrendThreshold)
      {
         bull[shift] = tma[shift];
      }
      else if(slope < -1 * TrendThreshold)
      {
         bear[shift] = tma[shift];
      }
      else
      {
         neutral[shift] = tma[shift];
      }
   }
   
  // if( slope > TrendThreshold )
 //  ObjectSetText("TMA","  Tma:  "    +DoubleToStr( lowerBand[0]/Point-lowerBand[1+TShift]/Point ,5),15, "Verdana", Lime);
   
 //   if(slope < -1 * TrendThreshold )
  // ObjectSetText("TMA","  Tma:  "    +DoubleToStr( lowerBand [0]/Point-lowerBand[1+TShift]/Point,5),15, "Verdana", Red);
   
   
  // double Ema= iMA(NULL, 0,EmaPeriod , 0, EmaMode, EmaPrice, 0);	
   //double Ema=iMA(NULL, 0,EmaPeriod , 0, EmaMode, EmaPrice, 0)-	lowerBand[0]/Point;
    double EmaUpper=((upperBand[shift+Bar]/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50, shift+Bar)/Point  )); 
    double EmaLower=((lowerBand[shift+Bar]/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50,shift+ Bar)/Point  )); 
    double EmaMed=        ((tma[shift+Bar]/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50, shift+Bar)/Point  )); 
     double RangeOC=   ((iMA(NULL, 0,EmaPeriod14 , 0, EmaMode, EmaPrice, Bar)/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50, Bar)/Point  )); 
     
     double EmaUpper2=((upperBand[shift+1]/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50, shift+1)/Point  )); 
     double EmaLower2=((lowerBand[shift+1]/Point-iMA(NULL, 0,EmaPeriod50 , 0, EmaMode50, EmaPrice50,shift+ 1)/Point  )); 
    //if(Upper50)
 
    double  RangeUpDn=(( upperBand[0]/Point -lowerBand[0]/Point ));
    double  RangeUpCL=(( Close[0]/Point -lowerBand[0]/Point )); 
   
   ObjectCreate("TMAl50L", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50L","L:"    +DoubleToStr( EmaLower,0),12, "Verdana", Gray);
   ObjectSet("TMAl50L", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50L", OBJPROP_XDISTANCE, 5);
   ObjectSet("TMAl50L", OBJPROP_YDISTANCE, 270);
   
    if(EmaLower>0  )
   ObjectSetText("TMAl50L","L:"    +DoubleToStr( EmaLower ,0),12, "Verdana", Lime);
   
    if(EmaLower<0 )
   ObjectSetText("TMAl50L","L:"    +DoubleToStr(EmaLower ,0),12, "Verdana", Red); 
   
   
   
   
    ObjectCreate("TMAl50M", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50M","M:"    +DoubleToStr( EmaMed,0),12, "Verdana", Gray);
   ObjectSet("TMAl50M", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50M", OBJPROP_XDISTANCE, 70);
   ObjectSet("TMAl50M", OBJPROP_YDISTANCE, 270);
   
    if(EmaMed>0  )
   ObjectSetText("TMAl50M","M:"    +DoubleToStr( EmaMed ,0),12, "Verdana", Lime);
   
    if(EmaMed<0 )
   ObjectSetText("TMAl50M","M:"    +DoubleToStr(EmaMed ,0),12, "Verdana", Red); 
   
   
   
   
   ObjectCreate("TMAl50H", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50H","H:"    +DoubleToStr( EmaUpper,0),12, "Verdana", Gray);
   ObjectSet("TMAl50H", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50H", OBJPROP_XDISTANCE, 150);
   ObjectSet("TMAl50H", OBJPROP_YDISTANCE, 270);
   
    if(EmaUpper>0  )
   ObjectSetText("TMAl50H","H:"    +DoubleToStr( EmaUpper ,0),12, "Verdana", Lime);
   
    if(EmaUpper<0 )
   ObjectSetText("TMAl50H","H:"    +DoubleToStr(EmaUpper ,0),12, "Verdana", Red);
   
   
    ObjectCreate("CustomBar5HLM", OBJ_LABEL, 0, 0, 0);
   ObjectSet("CustomBar5HLM", OBJPROP_CORNER, 1);
   ObjectSet("CustomBar5HLM", OBJPROP_XDISTANCE, 200);
   ObjectSet("CustomBar5HLM", OBJPROP_YDISTANCE, 50); 
   ObjectSetText("CustomBar5HLM",CharToStr(243),40,"Wingdings",Gray); 
   
    if(EmaMed>0&&EmaUpper>0 )
   ObjectSetText("CustomBar5HLM",CharToStr(246),35,"Wingdings",Green);   //246 Green
   
   if(EmaLower<0&&EmaMed<0
      
     //&&RangeUpDn>UpDn
   
    )
   ObjectSetText("CustomBar5HLM",CharToStr(248),35,"Wingdings",clrCrimson ); //248 clrCrimson 
   

    if(EmaLower>0&&EmaMed>0&&EmaUpper>0 )
   ObjectSetText("CustomBar5HLM",CharToStr(241),45,"Wingdings",Lime); 
   if(EmaLower<0&&EmaMed<0&&EmaUpper<0 )
   ObjectSetText("CustomBar5HLM",CharToStr(242),45,"Wingdings",Red); 
    
   
   
    ObjectCreate("TMAl50L2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50L2","Co:"    +DoubleToStr( RangeOC,0),12, "Verdana", Gray);
   ObjectSet("TMAl50L2", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50L2", OBJPROP_XDISTANCE, 200);
   ObjectSet("TMAl50L2", OBJPROP_YDISTANCE, 285);
   
    if(RangeOC>0  )
   ObjectSetText("TMAl50L2","CO:"    +DoubleToStr( RangeOC ,0),12, "Verdana", Lime);
   
    if(RangeOC<0 )
   ObjectSetText("TMAl50L2","Co:"    +DoubleToStr(RangeOC ,0),12, "Verdana", Red); 
   
   
   
   
    ObjectCreate("TMAl50L2rp", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50L2rp","RUpDn:"    +DoubleToStr( RangeUpDn,0),10, "Verdana", Gray);
   ObjectSet("TMAl50L2rp", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50L2rp", OBJPROP_XDISTANCE, 200);
   ObjectSet("TMAl50L2rp", OBJPROP_YDISTANCE, 100);
   
   
   
    if(RangeUpDn>50  )
   ObjectSetText("TMAl50L2rp","RUpDn:"    +DoubleToStr( RangeUpDn ,0),10, "Verdana", Lime);
   
 
   
   
   ObjectCreate("TMAl50L2rpuL", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl50L2rpuL","RUpCL:"    +DoubleToStr(  RangeUpCL,0),10, "Verdana", Gray);
   ObjectSet("TMAl50L2rpuL", OBJPROP_CORNER, 1);
   ObjectSet("TMAl50L2rpuL", OBJPROP_XDISTANCE, 200);
   ObjectSet("TMAl50L2rpuL", OBJPROP_YDISTANCE, 130);
   
  double T2= iRSI(NULL, PERIOD_M1,2, PRICE_CLOSE, shift)*2-100+((Close[shift]/Point-Open[shift]/Point));
  
  double RangeCL=((Low[shift]/Point- lowerBand[shift]/Point));
     double RangeCH=((High[shift]/Point- upperBand[shift]/Point));
    if(RangeCL<Dn
    &&T2<-90
   // EmaLower<0
    //&&EmaMed>0
    //&&EmaUpper>0 
   // &&T2<Dn
  // && Close[shift]/Point- tma[shift]/Point<Dn
   // &&EmaLower2<0
    )
 ArrowUp[shift]=Low[shift]-0.0001;
   if(RangeCH>Up
   
  // EmaUpper>0
  //&&EmaLower<0
   &&EmaMed<0
  // &&T2>Up
   // && Close[shift]/Point- tma[shift]/Point>Up
   //&&EmaUpper2>0
    )
  ArrowDn[shift]=High[shift]+0.0001;
  
  
  
  
  
  
  
  double T= iRSI(NULL, PERIOD_M1,2, PRICE_CLOSE, 0)*2-100+((Close[0]/Point-Open[0]/Point));
  double RangeCL2=((Low[1]/Point- lowerBand[1]/Point));
     double RangeCH2=((High[0]/Point- upperBand[0]/Point));
  
  
       if(RangeCL2> Dn  ){PlayedSoundH2 = False;}
   
       if(EmaUpper>0){PlayedSoundL2 = False;} 
      
      
       if( RangeCL2< Dn
      // && EmaLower>0
      // &&EmaMed>0
       //&&EmaUpper>0
       //&&EmaLower2<0
        
       && PlayedSoundH2 == False
        ){
       if(UPAlert)Alert(Symbol(), " (", Period(), "Snake-Alto " ,  RangeCL2 , "| EmaL |" ,EmaMed, " EmaM |", EmaUpper  , " EmaU |", T, " T |");
     
       if (SoundAlto) PlaySound(FileSoundUP);
       PlayedSoundH2 = True;}
         
         
       if( T>Up&& EmaUpper<0&&EmaLower<0&&EmaMed<0&&EmaUpper2>0
           
     // && Ma2001[Sh]>-214748364587525
     // && Ma100[0]>-214748364587525
       && PlayedSoundL2 == False){
       if(DOWNAlert)Alert(Symbol(), " (", Period(), "Snake-Basso " ,EmaUpper , "| Ma20 |"  , EmaMed , " RangeS |",  EmaLower , " Rsi |");
       if (SoundBasso) PlaySound(FileSoundDOWN);
       PlayedSoundL2 = True;}
  
   
}

     
//---------------------------------------------------------------------
double CalcTma( int inx )
  {
  double tma;
  if(inx >= TMAPeriod)
    tma = CalcPureTma(inx);
  else
    tma = CalcTmaEstimate(inx);
  return( tma );
  }
  
//---------------------------------------------------------------------
double CalcPureTma( int i )
  {
  int j = TMAPeriod + 1; 
  int k;
  double sum = j * iClose(NULL, TimeFrameValue, i);
  for (k = 1; k <= TMAPeriod; k++)
    sum = sum + (j - k) * (iClose(NULL, TimeFrameValue, i+k) + iClose(NULL, TimeFrameValue, i-k));
  return( sum / FullSumW );
  }

//---------------------------------------------------------------------
double CalcTmaEstimate( int i )
//only returns correct result if i <= TMAPeriod
  {
  double sum = 0;
  double sumW;
  int k,
      j = TMAPeriod + 1;
      sumW = 0;
  // compute left half
  for (k = 0; k <= TMAPeriod; k++)
    {
    sum += (j - k) * iClose(NULL, TimeFrameValue, i+k);
    sumW += (j - k);
    }
  // compute right half
  j = TMAPeriod;
  for (k = i-1; k >= 0; k--)
    {
    sum += j * iClose(NULL, TimeFrameValue, k);
    sumW += j;
    j--;
    }
    
  PriorTick = Close[0];
  return( sum / sumW );
  }

//---------------------------------------------------------------------
// if the next tick arrives but it still goes in the same bar, this
// function updates the latest value without a complete recalculation
double CalcTmaUpdate( double PreviousTma )
  {
  double r = PreviousTma + (Close[0] - PriorTick) * TickScaleFactor;
  PriorTick = Close[0];
  /*
   ObjectCreate("TMA", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMA","  Tma:  "    +DoubleToStr( lowerBand[0]/Point-lowerBand[1+TShift]/Point,5),15, "Verdana", Gray);
   ObjectSet("TMA", OBJPROP_CORNER, 1);
   ObjectSet("TMA", OBJPROP_XDISTANCE, 40);
   ObjectSet("TMA", OBJPROP_YDISTANCE, 260);
   
    
   
   
   ObjectCreate("TMAc", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAc","  Tmac:  "    +DoubleToStr( Close[0]/Point-tma[0]/Point,2),15, "Verdana", Gray);
   ObjectSet("TMAc", OBJPROP_CORNER, 1);
   ObjectSet("TMAc", OBJPROP_XDISTANCE, 40);
   ObjectSet("TMAc", OBJPROP_YDISTANCE, 280);
   
    if(Close[0]/Point-tma[0]/Point>0  )
   ObjectSetText("TMAc","  Tmac:  "    +DoubleToStr( Close[0]/Point-tma[0]/Point ,2),15, "Verdana", Lime);
   
    if(Close[0]/Point-tma[0]/Point<0 )
   ObjectSetText("TMAc","  Tmac:  "    +DoubleToStr( Close [0]/Point-tma[0]/Point,2),15, "Verdana", Red);
   
   
   
   ObjectCreate("TMAl", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TMAl","  Tmalow:  "    +DoubleToStr( Close[0]/Point-lowerBand[0]/Point,2),15, "Verdana", Gray);
   ObjectSet("TMAl", OBJPROP_CORNER, 1);
   ObjectSet("TMAl", OBJPROP_XDISTANCE, 40);
   ObjectSet("TMAl", OBJPROP_YDISTANCE, 300);
   
    if(Close[0]/Point-lowerBand[0]/Point>0  )
   ObjectSetText("TMAl","  Tmalow:  "    +DoubleToStr( Close[0]/Point-lowerBand[0]/Point ,2),15, "Verdana", Lime);
   
    if(Close[0]/Point-lowerBand[0]/Point<0 )
   ObjectSetText("TMAl","  Tmalow:  "    +DoubleToStr( Close [0]/Point-lowerBand[0]/Point,2),15, "Verdana", Red);
    */
   
  
 
  return( r );
  }
//---------------------------------------------------------------------

void manageAlerts()
{
   if (alertsOn)
   { 
      int trend;        
      if (Close[0] > upperBand[0]>3) trend =  1;
      else if (Close[0] < lowerBand[0]) trend = -1;
      else {AlertHappened = false;}
            
      if (!AlertHappened && AlertTime != Time[0])
      {       
         if (trend == 1) doAlert("up");
         if (trend ==-1) doAlert("down");
      }         
   }
}


void doAlert(string doWhat)
{ 
   if (AlertHappened) return;
   AlertHappened = true;
   AlertTime = Time[0];
   string message;
     
   message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," "+TimeFrameValueToString(TimeFrameValue)+" TMA bands price penetrated ",doWhat," band");
   if (alertsMessage) Alert(message);
   if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TMA bands "),message);
   if (alertsSound)   PlaySound("news.wav");

}

//+-------------------------------------------------------------------
//|   Time Frame Handlers                                                               
//+-------------------------------------------------------------------


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};


int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
   {
      if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) 
      {
//         return(MathMax(iTfTable[i],Period()));
         return(iTfTable[i]);
      }
   }
   return(Period());
   
}
string TimeFrameValueToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int charX = StringGetChar(s, length);
         if((charX > 96 && charX < 123) || (charX > 223 && charX < 256))
                     s = StringSetChar(s, length, charX - 32);
         else if(charX > -33 && charX < 0)
                     s = StringSetChar(s, length, charX + 224);
   }
   
   
   
   
   return(s);
}